"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = void 0;

var _path = require("path");

var _access = _interopRequireDefault(require("../../lib/cmd/access"));

var _exec = _interopRequireDefault(require("../../lib/cmd/exec"));

const gitInit = async ({
  cwd,
  log
}) => {
  const path = (0, _path.join)(cwd, '.git');
  const isExists = await (0, _access.default)(path);

  if (!isExists) {
    log.info('Initialize the Git repository');
    await (0, _exec.default)({
      cmd: 'git',
      args: ['init'],
      cwd,
      log
    });
  } else {
    log.info('Git repository already exists');
  }
};

var _default = gitInit;
exports.default = _default;