"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = void 0;

var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));

var _trim = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/trim"));

var _exec = _interopRequireDefault(require("../../lib/cmd/exec"));

const modes = ['modified', 'others'];

const gitLs = async ({
  cwd,
  log
}, {
  mode
}) => {
  log.info('Get the list of modified or other files');
  const args = ['ls-files', '--exclude-standard'];

  if (mode === 'all') {
    args.push(...(0, _map.default)(modes).call(modes, v => `--${v}`));
  } else {
    args.push(`--${mode}`);
  }

  const {
    stdout
  } = await (0, _exec.default)({
    cmd: 'git',
    args,
    cwd,
    log
  });
  log.info('Return a list of modified or other files');

  if ((0, _trim.default)(stdout).call(stdout) === '') {
    log.debug('No modified or other files were found');
    return [];
  }

  const files = (0, _trim.default)(stdout).call(stdout).split('\n');
  log.info((0, _map.default)(files).call(files, file => `▸ ${file}`));
  return files;
};

var _default = gitLs;
exports.default = _default;