"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = void 0;

var _trim = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/trim"));

var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));

var _exec = _interopRequireDefault(require("../../lib/cmd/exec"));

const gitStaged = async ({
  cwd,
  log
}) => {
  log.info('Get the list of staged files');
  const {
    stdout
  } = await (0, _exec.default)({
    cmd: 'git',
    args: ['diff', '--staged', '--name-only'],
    cwd,
    log
  });

  if ((0, _trim.default)(stdout).call(stdout) === '') {
    log.debug('No staged files were found');
    return [];
  }

  const files = (0, _trim.default)(stdout).call(stdout).split('\n');
  log.info((0, _map.default)(files).call(files, file => `▸ ${file}`));
  return files;
};

var _default = gitStaged;
exports.default = _default;