"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = void 0;

var _sort = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/sort"));

var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));

var _toolLib = require("@kettil/tool-lib");

var _exec = _interopRequireDefault(require("../../lib/cmd/exec"));

const npmInstall = async ({
  cwd,
  log
}, {
  packages,
  mode
}) => {
  if (packages.length > 0) {
    const uniquePackages = (0, _toolLib.uniqueArray)((0, _sort.default)(packages).call(packages, _toolLib.compareAsc));
    const parameters = ['install', `--save-${mode}`, '--save-exact', ...uniquePackages];
    const logPackages = (0, _map.default)(uniquePackages).call(uniquePackages, name => `▸ ${name}`).join('\n');
    log.info(`Install following ${mode} packages:\n${logPackages}`);
    await (0, _exec.default)({
      cmd: 'npm',
      args: parameters,
      cwd,
      log
    });
  }
};

var _default = npmInstall;
exports.default = _default;