"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = exports.getPackagePath = void 0;

var _path = require("path");

var _access = _interopRequireDefault(require("../../lib/cmd/access"));

var _readFile = _interopRequireDefault(require("../../lib/cmd/readFile"));

const getPackagePath = cwd => (0, _path.join)(cwd, 'package.json');

exports.getPackagePath = getPackagePath;

const npmPackageLoad = async ({
  cwd,
  log
}, {
  key,
  throwError
}) => {
  const path = getPackagePath(cwd);
  const isExists = await (0, _access.default)(path);

  if (!isExists) {
    throw new Error('package.json is not found');
  }

  log.debug('Read the package.json');
  const config = await (0, _readFile.default)(path, true);

  if (typeof key === 'undefined') {
    return config;
  }

  const value = config[key];

  if (throwError && typeof value === 'undefined') {
    throw new TypeError(`The package.json value "${key}" is undefiend`);
  }

  return value;
};

var _default = npmPackageLoad;
exports.default = _default;