"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireWildcard = require("@babel/runtime-corejs3/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = void 0;

var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));

var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));

var _toolLib = require("@kettil/tool-lib");

var _writeFile = _interopRequireDefault(require("../../lib/cmd/writeFile"));

var _packageLoad = _interopRequireWildcard(require("./packageLoad"));

const update = (config, values) => {
  if ((0, _toolLib.objectKeys)(values).length === 0) {
    return config;
  }

  return (0, _assign.default)((0, _toolLib.isObject)(config) ? config : {}, values);
};

const updatePeerDependencies = (config, values) => {
  const peerDependencies = {};
  const packages = config.devDependencies;

  if (!(0, _toolLib.isObject)(packages)) {
    throw new Error('In the package.json is the devDependencies empty');
  }

  (0, _forEach.default)(values).call(values, value => {
    const version = packages[value];

    if (typeof version !== 'string') {
      throw new TypeError(`The peerDependency "${value}" is not found in the devDependencies`);
    }

    peerDependencies[value] = version;
  });
  return update(config.peerDependencies, peerDependencies);
};

const npmPackageUpdate = async (argv, {
  settings: {
    bin,
    scripts,
    peerDependencies,
    ...settings
  }
}) => {
  const {
    cwd,
    log
  } = argv;
  const config = await (0, _packageLoad.default)(argv, {});

  if (!(0, _toolLib.isObject)(config)) {
    throw new TypeError('Package could not be interpreted as an object');
  }

  (0, _assign.default)(config, settings); // Update the bin part

  if (bin) {
    config.bin = update(config.bin, bin);
  } // Update the scripts part


  if (scripts) {
    config.scripts = update(config.scripts, scripts);
  } // Update the peerDependencies part


  if (peerDependencies && peerDependencies.length > 0) {
    config.peerDependencies = updatePeerDependencies(config, peerDependencies);
  }

  log.info('Extend the package.json');
  await (0, _writeFile.default)((0, _packageLoad.getPackagePath)(cwd), config);
};

var _default = npmPackageUpdate;
exports.default = _default;