"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = void 0;

var _exec = _interopRequireDefault(require("../../lib/cmd/exec"));

var _helper = require("../../lib/helper");

const configs = ['babel.config.js', 'babel.config.json'];

const babel = async ({
  cwd,
  log
}) => {
  const hasConfigFile = await (0, _helper.existConfigFile)(cwd, configs);

  if (!hasConfigFile) {
    throw new Error(`Babel config file was not found (${configs.join(', ')})`);
  }

  const cmd = './node_modules/.bin/babel';
  const args = []; // options

  args.push('-d', 'build');
  args.push('--extensions', '.ts,.tsx'); // path

  args.push('src');
  log.info('Run babel');
  await (0, _exec.default)({
    cmd,
    args,
    cwd,
    log
  });
};

var _default = babel;
exports.default = _default;