"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireWildcard = require("@babel/runtime-corejs3/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = void 0;

var _keys = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/keys"));

var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));

var _sort = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/sort"));

var _chalk = require("chalk");

var _depcheck = _interopRequireWildcard(require("depcheck"));

var _dependencyError = _interopRequireDefault(require("../../lib/errors/dependencyError"));

const options = {
  ignoreDirs: ['node_modules'],
  parsers: {
    '*.js': _depcheck.parser.es6,
    '*.jsx': _depcheck.parser.jsx,
    '*.ts': _depcheck.parser.typescript,
    '*.tsx': _depcheck.parser.typescript
  },
  detectors: [_depcheck.detector.requireCallExpression, _depcheck.detector.importDeclaration],
  specials: [_depcheck.special.babel, _depcheck.special.eslint, _depcheck.special.prettier, _depcheck.special.jest, _depcheck.special.husky, _depcheck.special.webpack]
};

const depcheck = async ({
  cwd
}) => {
  const {
    dependencies,
    devDependencies,
    invalidDirs,
    invalidFiles
  } = await (0, _depcheck.default)(cwd, options);
  const msg = [];

  if ((0, _keys.default)(invalidDirs).length > 0) {
    var _context, _context2;

    msg.push((0, _chalk.red)('No access to the folders:'));
    (0, _forEach.default)(_context = (0, _sort.default)(_context2 = (0, _keys.default)(invalidDirs)).call(_context2)).call(_context, file => {
      msg.push(`- ${file}`);
    });
    msg.push('');
  }

  if ((0, _keys.default)(invalidFiles).length > 0) {
    var _context3, _context4;

    msg.push((0, _chalk.red)('No access or syntax error in the files:'));
    (0, _forEach.default)(_context3 = (0, _sort.default)(_context4 = (0, _keys.default)(invalidFiles)).call(_context4)).call(_context3, file => {
      msg.push(`- ${file}`);
    });
    msg.push('');
  }

  if (dependencies.length > 0 || devDependencies.length > 0) {
    var _context5, _context6;

    msg.push((0, _chalk.red)('The dependencies are not used:'));
    (0, _forEach.default)(_context5 = (0, _sort.default)(_context6 = [...dependencies, ...devDependencies]).call(_context6)).call(_context5, file => {
      msg.push(`- ${file}`);
    });
  }

  if (msg.length > 0) {
    throw new _dependencyError.default('Depcheck error', msg);
  }
};

var _default = depcheck;
exports.default = _default;