"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = exports.extensionAll = void 0;

var _path = require("path");

var _exec = _interopRequireDefault(require("../../lib/cmd/exec"));

var _helper = require("../../lib/helper");

const configs = ['.eslintrc.js', '.eslintrc.cjs', '.eslintrc.yaml', '.eslintrc.yml', '.eslintrc.json', '.eslintrc'];
const extensionAll = 'js,ts,tsx';
exports.extensionAll = extensionAll;

const eslint = async ({
  cwd,
  cfg,
  log
}, {
  write,
  files
}) => {
  const hasConfigFile = await (0, _helper.existConfigFile)(cwd, configs);
  const cmd = './node_modules/.bin/eslint';
  const args = ['--color', '--max-warnings', '0'];

  if (!hasConfigFile) {
    args.push('--config', (0, _path.relative)(cwd, (0, _path.join)(cfg, 'eslintrc.json')));
  }

  if (write) {
    args.push('--fix');
  } else {
    args.push('--format', 'codeframe');
  }

  if (files) {
    if (files.length === 0) {
      log.info('No files found for eslint');
      return;
    }

    args.push(...files);
  } else {
    args.push('--ext', `"${extensionAll}"`);
    args.push('.');
  }

  log.info('Run eslint');
  await (0, _exec.default)({
    cmd,
    args,
    cwd,
    log
  });
};

var _default = eslint;
exports.default = _default;