"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = exports.extensionAll = exports.extensionCi = void 0;

var _path = require("path");

var _exec = _interopRequireDefault(require("../../lib/cmd/exec"));

var _helper = require("../../lib/helper");

const configs = ['.prettierrc', '.prettierrc.json', '.prettierrc.yml', '.prettierrc.yaml', '.prettierrc.toml', '.prettierrc.js', 'prettier.config.js'];
const extensionCi = 'json,md,scss,yml,yaml,html';
exports.extensionCi = extensionCi;
const extensionAll = `ts,tsx,js,jsx,${extensionCi}`;
exports.extensionAll = extensionAll;

const prettier = async ({
  cwd,
  cfg,
  log
}, {
  write,
  files,
  extension = extensionAll
}) => {
  const hasConfigFile = await (0, _helper.existConfigFile)(cwd, configs);
  const cmd = './node_modules/.bin/prettier';
  const args = [];

  if (!hasConfigFile) {
    args.push('--config', (0, _path.relative)(cwd, (0, _path.join)(cfg, 'prettierrc.json')));
  }

  if (write) {
    args.push('--write');
  } else {
    args.push('--list-different');
  }

  if (files) {
    if (files.length === 0) {
      log.info('No files found for prettier');
      return;
    }

    args.push(...files);
  } else {
    args.push(`"./**/*.{${extension}}"`);
  }

  log.info('Run prettier');
  await (0, _exec.default)({
    cmd,
    args,
    cwd,
    log
  });
};

var _default = prettier;
exports.default = _default;