"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = void 0;

var _path = require("path");

var _exec = _interopRequireDefault(require("../../lib/cmd/exec"));

var _helper = require("../../lib/helper");

const configs = ['tsconfig.json'];

const tsc = async ({
  cwd,
  log
}, {
  mode
}) => {
  const hasConfigFile = await (0, _helper.existConfigFile)(cwd, configs);

  if (!hasConfigFile) {
    throw new Error(`TypeScript config file was not found (${configs.join(', ')})`);
  }

  const cmd = './node_modules/.bin/tsc';
  const args = [];

  switch (mode) {
    case 'type-check':
      args.push('--outDir', (0, _path.join)(cwd, 'build'));
      args.push('--project', (0, _path.join)(cwd, 'tsconfig.json'));
      args.push('--noEmit');
      args.push('--isolatedModules', 'false');
      break;

    case 'type-create':
      args.push('--outDir', (0, _path.join)(cwd, 'build'));
      args.push('--project', (0, _path.join)(cwd, 'tsconfig.build.json'));
      args.push('--noEmit', 'false');
      args.push('--emitDeclarationOnly');
      break;

    default:
      throw new Error(`Mode is unknown: ${String(mode)}`);
  }

  log.info('Run TypeScript');
  await (0, _exec.default)({
    cmd,
    args,
    cwd,
    log
  });
};

var _default = tsc;
exports.default = _default;