"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = void 0;

var _exec = _interopRequireDefault(require("../../lib/cmd/exec"));

var _helper = require("../../lib/helper");

const configs = ['webpack.config.js'];

const webpack = async ({
  cwd,
  log
}) => {
  const hasConfigFile = await (0, _helper.existConfigFile)(cwd, configs);

  if (!hasConfigFile) {
    throw new Error(`Webpack config file was not found (${configs.join(', ')})`);
  }

  const cmd = './node_modules/.bin/webpack';
  const args = [];
  log.info('Run Webpack');
  await (0, _exec.default)({
    cmd,
    args,
    cwd,
    log
  });
};

var _default = webpack;
exports.default = _default;