#!/usr/bin/env node
"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

var _path = require("path");

var _chalk = _interopRequireDefault(require("chalk"));

var _yargs = _interopRequireDefault(require("yargs"));

var _logger = _interopRequireDefault(require("../lib/cli/logger"));

const cwd = process.cwd();
const tpl = (0, _path.join)(__dirname, '..', '..', 'templates');
const cfg = (0, _path.join)(__dirname, '..', '..', 'configs');
const epilogue = [`Run ${_chalk.default.bold('carna <command> --help')} to display the options of the commands `, '', 'For more information, find our manual at https://github.com/kettil/carna'];
_yargs.default.locale('en').option('verbose', {
  default: false,
  alias: 'v',
  type: 'boolean',
  desc: 'Print info messages'
}).option('vvv', {
  default: false,
  type: 'boolean',
  desc: 'Print info/debug messages'
}).option('cwd', {
  default: cwd,
  type: 'string',
  hidden: true
}).option('tpl', {
  default: tpl,
  type: 'string',
  hidden: true
}).option('cfg', {
  default: cfg,
  type: 'string',
  hidden: true
}).middleware(argv => ({
  log: (0, _logger.default)(argv)
})).commandDir('../sequences').demandCommand(1, 1).usage('Usage: $0 <command> [options]').epilogue(epilogue.join('\n')).help().version().argv;