"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.errorHandler = exports.builderDefault = void 0;

var _dependencyError = _interopRequireDefault(require("../errors/dependencyError"));

var _executableError = _interopRequireDefault(require("../errors/executableError"));

const builderDefault = (cmd, callback) => yargs => callback(yargs).usage(`Usage: $0 ${cmd} [options]`).help().version(false).showHelpOnFail(false);

exports.builderDefault = builderDefault;

const errorHandler = (argv, error) => {
  if (error instanceof _executableError.default) {
    argv.log.log(error.stdout);
    argv.log.log(error.stderr);
    /* eslint-disable-next-line node/no-process-exit, unicorn/no-process-exit */

    process.exit(1);
  }

  if (error instanceof _dependencyError.default) {
    argv.log.log(error.list);
    /* eslint-disable-next-line node/no-process-exit, unicorn/no-process-exit */

    process.exit(1);
  }

  throw error;
};

exports.errorHandler = errorHandler;