"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = void 0;

var _promise = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/promise"));

var _child_process = require("child_process");

var _toolLib = require("@kettil/tool-lib");

var _executableError = _interopRequireDefault(require("../errors/executableError"));

const exec = ({
  cmd,
  args = [],
  output,
  cwd = process.cwd(),
  env = (0, _toolLib.env)(),
  log
}) => new _promise.default((resolve, reject) => {
  const command = `${cmd} ${args.join(' ')}`;
  log.debug(`\nexec: ${command}`);
  const stream = (0, _child_process.spawn)(cmd, args, {
    cwd,
    env,
    shell: true
  });
  let stdout = '';
  let stderr = '';
  stream.stdout.on('data', data => {
    stdout += String(data);
    log.debug(String(data));

    if (output) {
      output(String(data));
    }
  });
  stream.stderr.on('data', data => {
    stderr += String(data);
    log.debug(String(data));

    if (output) {
      output(String(data));
    }
  });
  stream.on('close', code => {
    if (typeof code === 'number' && code !== 0) {
      reject(new _executableError.default(stderr, command, code, stdout, stderr));
    } else {
      resolve({
        stdout,
        stderr
      });
    }
  });
});

var _default = exec;
exports.default = _default;