"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.handler = exports.builder = exports.desc = exports.command = void 0;

var _depcheck = _interopRequireDefault(require("../actions/tools/depcheck"));

var _spinner = require("../lib/cli/spinner");

var _yargs = require("../lib/cli/yargs");

var _logo = _interopRequireDefault(require("../lib/logo"));

const command = 'debs';
exports.command = command;
const desc = 'Run the dependency check';
exports.desc = desc;
const options = {
  group: `${command}-Options`
};
const builder = (0, _yargs.builderDefault)(command, yargs => yargs.options({
  ci: { ...options,
    type: 'boolean',
    default: false,
    describe: 'Run it in CI mode'
  }
}));
exports.builder = builder;

const handler = async argv => {
  try {
    if (argv.ci) {
      await (0, _depcheck.default)(argv);
    } else {
      await (0, _logo.default)();
      await (0, _spinner.spinnerAction)((0, _depcheck.default)(argv), 'DepCheck');
    }
  } catch (error) {
    (0, _yargs.errorHandler)(argv, error);
  }
};

exports.handler = handler;