"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.handler = exports.builder = exports.desc = exports.command = void 0;

var _trim = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/trim"));

var _slice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/slice"));

var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));

var _yargs = require("../lib/cli/yargs");

var _commit = _interopRequireDefault(require("./git/commit"));

var _msg = _interopRequireDefault(require("./git/msg"));

var _push = _interopRequireDefault(require("./git/push"));

var _context;

const command = 'git <hook>';
exports.command = command;
const desc = 'Handler for the git hooks';
exports.desc = desc;
const mode = ['msg', 'commit', 'push'];
const options = {
  group: `${(0, _trim.default)(_context = (0, _slice.default)(command).call(command, 0, Math.max(0, (0, _indexOf.default)(command).call(command, '<')))).call(_context)}-Options`
};
const builder = (0, _yargs.builderDefault)(command, yargs => yargs.positional('hook', {
  choices: mode,
  demandOption: true
}).options({
  edit: { ...options,
    type: 'string',
    desc: 'Path to the COMMIT_EDITMSG file (only at hook "msg")'
  }
}));
exports.builder = builder;

const handler = async argv => {
  try {
    const {
      edit,
      hook
    } = argv;

    switch (hook) {
      case 'commit':
        await (0, _commit.default)(argv);
        break;

      case 'msg':
        if (typeof edit !== 'string' || (0, _trim.default)(edit).call(edit) === '') {
          throw new Error(`Argument "edit" is required at hook "${hook}"`);
        }

        await (0, _msg.default)(argv, {
          edit
        });
        break;

      case 'push':
        await (0, _push.default)(argv);
        break;

      default:
        throw new Error(`The hook "${hook}" is unknown`);
    }
  } catch (error) {
    (0, _yargs.errorHandler)(argv, error);
  }
};

exports.handler = handler;