export declare type Settings = {
    files: string[];
    folders: string[];
    templates: Array<[string, string] | [string]>;
    libraryProduction: string[];
    libraryDevelopment: string[];
    packageBin: Record<string, string>;
    packageInit: Record<string, Record<string, string> | boolean | number | string>;
    packageUpdate: Record<string, Record<string, string> | boolean | number | string>;
    packageScripts: Record<string, string>;
    packagePeerDependencies: string[];
    github: {
        name?: string;
    };
};
export declare type Props = {
    readonly cli: boolean;
    readonly package: boolean;
    readonly react?: boolean;
    readonly github?: string;
    readonly noCommit: boolean;
};
declare const getSettings: (argv: Props) => Settings;
export default getSettings;
