"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = void 0;

var _promise = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/promise"));

var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));

var _toolLib = require("@kettil/tool-lib");

var _template = _interopRequireDefault(require("../../actions/node/template"));

var _spinner = require("../../lib/cli/spinner");

const templateAction = async (argv, settings, packageName) => {
  var _context;

  /* eslint-disable @typescript-eslint/naming-convention */
  const variables = {
    GITHUB_USERNAME: settings.github.name,
    PACKAGE_LIBRARY: (0, _toolLib.toCamelCase)(packageName),
    PACKAGE_FILENAME: packageName
  };

  if (!argv.package || argv.cli) {
    variables.BABEL_MODULE_TYPE = 'commonjs';
    variables.BABEL_MODULE_TARGET = 'defaults';
  } else {
    variables.BABEL_MODULE_TYPE = false;
    variables.BABEL_MODULE_TARGET = {
      node: '14'
    };
  }
  /* eslint-enable @typescript-eslint/naming-convention */


  await (0, _spinner.spinnerAction)(_promise.default.all((0, _map.default)(_context = settings.templates).call(_context, ([source, target]) => (0, _template.default)(argv, {
    source,
    target,
    variables
  }))), 'Create template files');
};

var _default = templateAction;
exports.default = _default;